stupid big jimmy. fix bug in previous bug fix.
[monkeysphere.git] / src / common
index 5bb0b79fac779d08348721f2d3e5d6df0f29ed5a..9d7deb7c6251c7ab989f53b49e29fc6e69b6971d 100644 (file)
 # managed directories
 ETC="/etc/monkeysphere"
 export ETC
-CACHE="/var/cache/monkeysphere"
-export CACHE
 
 ########################################################################
 ### UTILITY FUNCTIONS
 
-error() {
-    log "$1"
-    ERR=${2:-'1'}
-}
-
+# failure function.  exits with code 255, unless specified otherwise.
 failure() {
     echo "$1" >&2
-    exit ${2:-'1'}
+    exit ${2:-'255'}
 }
 
 # write output to stderr
@@ -44,12 +38,12 @@ loge() {
 
 # cut out all comments(#) and blank lines from standard input
 meat() {
-    grep -v -e "^[[:space:]]*#" -e '^$'
+    grep -v -e "^[[:space:]]*#" -e '^$' "$1"
 }
 
 # cut a specified line from standard input
 cutline() {
-    head --line="$1" | tail -1
+    head --line="$1" "$2" | tail -1
 }
 
 # check that characters are in a string (in an AND fashion).
@@ -70,11 +64,45 @@ check_capability() {
     return 0
 }
 
-# convert escaped characters from gpg output back into original
-# character
-# FIXME: undo all escape character translation in with-colons gpg output
-unescape() {
-    echo "$1" | sed 's/\\x3a/:/'
+# hash of a file
+file_hash() {
+    md5sum "$1" 2> /dev/null
+}
+
+# convert escaped characters in pipeline from gpg output back into
+# original character
+# FIXME: undo all escape character translation in with-colons gpg
+# output
+gpg_unescape() {
+    sed 's/\\x3a/:/g'
+}
+
+# convert nasty chars into gpg-friendly form in pipeline
+# FIXME: escape everything, not just colons!
+gpg_escape() {
+    sed 's/:/\\x3a/g'
+}
+
+# prompt for GPG-formatted expiration, and emit result on stdout
+get_gpg_expiration() {
+    local keyExpire=
+
+    cat >&2 <<EOF
+Please specify how long the key should be valid.
+         0 = key does not expire
+      <n>  = key expires in n days
+      <n>w = key expires in n weeks
+      <n>m = key expires in n months
+      <n>y = key expires in n years
+EOF
+    while [ -z "$keyExpire" ] ; do
+       read -p "Key is valid for? (0) " keyExpire
+       if ! test_gpg_expire ${keyExpire:=0} ; then
+           echo "invalid value" >&2
+           unset keyExpire
+       fi
+    done
+    echo "$keyExpire"
 }
 
 # remove all lines with specified string from specified file
@@ -85,9 +113,41 @@ remove_line() {
     file="$1"
     string="$2"
 
-    if [ "$file" -a "$string" ] ; then
-       grep -v "$string" "$file" | sponge "$file"
+    if [ -z "$file" -o -z "$string" ] ; then
+       return 1
+    fi
+
+    if [ ! -e "$file" ] ; then
+       return 1
+    fi
+
+    # if the string is in the file...
+    if grep -q -F "$string" "$file" 2> /dev/null ; then
+       # remove the line with the string, and return 0
+       grep -v -F "$string" "$file" | sponge "$file"
+       return 0
+    # otherwise return 1
+    else
+       return 1
+    fi
+}
+
+# remove all lines with MonkeySphere strings in file
+remove_monkeysphere_lines() {
+    local file
+
+    file="$1"
+
+    if [ -z "$file" ] ; then
+       return 1
+    fi
+
+    if [ ! -e "$file" ] ; then
+       return 1
     fi
+
+    egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
+       "$file" | sponge "$file"
 }
 
 # translate ssh-style path variables %h and %u
@@ -109,30 +169,64 @@ translate_ssh_variables() {
     echo "$path"
 }
 
+# test that a string to conforms to GPG's expiration format
+test_gpg_expire() {
+    echo "$1" | egrep -q "^[0-9]+[mwy]?$"
+}
+
+# check that a file is properly owned, and that all it's parent
+# directories are not group/other writable
+check_key_file_permissions() {
+    local user
+    local path
+    local access
+    local gAccess
+    local oAccess
+
+    # function to check that an octal corresponds to writability
+    is_write() {
+       [ "$1" -eq 2 -o "$1" -eq 3 -o "$1" -eq 6 -o "$1" -eq 7 ]
+    }
+
+    user="$1"
+    path="$2"
+
+    # return 0 is path does not exist
+    [ -e "$path" ] || return 0
+
+    owner=$(stat --format '%U' "$path")
+    access=$(stat --format '%a' "$path")
+    gAccess=$(echo "$access" | cut -c2)
+    oAccess=$(echo "$access" | cut -c3)
+
+    # check owner
+    if [ "$owner" != "$user" -a "$owner" != 'root' ] ; then
+       return 1
+    fi
+
+    # check group/other writability
+    if is_write "$gAccess" || is_write "$oAccess" ; then
+       return 2
+    fi
+
+    if [ "$path" = '/' ] ; then
+       return 0
+    else
+       check_key_file_permissions $(dirname "$path")
+    fi
+}
+
 ### CONVERSION UTILITIES
 
 # output the ssh key for a given key ID
 gpg2ssh() {
     local keyID
     
-    #keyID="$1" #TMP
-    # only use last 16 characters until openpgp2ssh can take all 40 #TMP
-    keyID=$(echo "$1" | cut -c 25-) #TMP
+    keyID="$1"
 
     gpg --export "$keyID" | openpgp2ssh "$keyID" 2> /dev/null
 }
 
-# output the ssh key for a given secret key ID
-gpgsecret2ssh() {
-    local keyID
-
-    #keyID="$1" #TMP
-    # only use last 16 characters until openpgp2ssh can take all 40 #TMP
-    keyID=$(echo "$1" | cut -c 25-) #TMP
-
-    gpg --export-secret-key "$keyID" | openpgp2ssh "$keyID" 2> /dev/null
-}
-
 # output known_hosts line from ssh key
 ssh2known_hosts() {
     local host
@@ -198,6 +292,11 @@ gpg2authorized_keys() {
 # (not just first N (5 in this case))
 gpg_fetch_userid() {
     local userID
+    local returnCode
+
+    if [ "$CHECK_KEYSERVER" != 'true' ] ; then
+       return 0
+    fi
 
     userID="$1"
 
@@ -206,18 +305,16 @@ gpg_fetch_userid() {
        gpg --quiet --batch --with-colons \
        --command-fd 0 --keyserver "$KEYSERVER" \
        --search ="$userID" > /dev/null 2>&1
+    returnCode="$?"
     loge "done."
-}
 
-# get the full fingerprint of a key ID
-get_key_fingerprint() {
-    local keyID
-
-    keyID="$1"
+    # if the user is the monkeysphere user, then update the
+    # monkeysphere user's trustdb
+    if [ $(id -un) = "$MONKEYSPHERE_USER" ] ; then
+       gpg_authentication "--check-trustdb" > /dev/null 2>&1
+    fi
 
-    gpg --list-key --with-colons --fixed-list-mode \
-       --with-fingerprint --with-fingerprint "$keyID" | \
-       grep '^fpr:' | grep "$keyID" | cut -d: -f10
+    return "$returnCode"
 }
 
 ########################################################################
@@ -231,7 +328,7 @@ get_key_fingerprint() {
 # (see /usr/share/doc/gnupg/DETAILS.gz)
 # output is one line for every found key, in the following format:
 #
-# flag fingerprint
+# flag:fingerprint
 #
 # "flag" is an acceptability flag, 0 = ok, 1 = bad
 # "fingerprint" is the fingerprint of the key
@@ -263,11 +360,8 @@ process_user_id() {
     fi
     requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
 
-    # if CHECK_KEYSERVER variable set to true, check the keyserver
-    # for the user ID
-    if [ "$CHECK_KEYSERVER" = "true" ] ; then
-       gpg_fetch_userid "$userID"
-    fi
+    # fetch the user ID if necessary/requested
+    gpg_fetch_userid "$userID"
 
     # output gpg info for (exact) userid and store
     gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
@@ -276,13 +370,11 @@ process_user_id() {
 
     # if the gpg query return code is not 0, return 1
     if [ "$?" -ne 0 ] ; then
-        log "  - key not found."
+        log " no primary keys found."
         return 1
     fi
 
     # loop over all lines in the gpg output and process.
-    # need to do it this way (as opposed to "while read...") so that
-    # variables set in loop will be visible outside of loop
     echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
     while IFS=: read -r type validity keyid uidfpr usage ; do
        # process based on record type
@@ -322,29 +414,41 @@ process_user_id() {
                fi
                ;;
            'uid') # user ids
-               # if an acceptable user ID was already found, skip
-               if [ "$uidOK" ] ; then
+               if [ "$lastKey" != pub ] ; then
+                   log " - got a user ID after a sub key?!  user IDs should only follow primary keys!"
                    continue
                fi
-               # if the user ID does not match, skip
-               if [ "$(unescape "$uidfpr")" != "$userID" ] ; then
+               # if an acceptable user ID was already found, skip
+               if [ "$uidOK" = 'true' ] ; then
                    continue
                fi
-               # if the user ID validity is not ok, skip
-               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+               # if the user ID does matches...
+               if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
+                   # and the user ID validity is ok
+                   if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
+                       # mark user ID acceptable
+                       uidOK=true
+                   fi
+               else
                    continue
                fi
 
-               # mark user ID acceptable
-               uidOK=true
-
                # output a line for the primary key
                # 0 = ok, 1 = bad
                if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
-                   log "  * acceptable key found."
-                   echo "0:${fingerprint}"
+                   log "  * acceptable primary key."
+                   if [ -z "$sshKey" ] ; then
+                       log "    ! primary key could not be translated (not RSA or DSA?)."
+                   else
+                       echo "0:${sshKey}"
+                   fi
                else
-                   echo "1:${fingerprint}"
+                   log "  - unacceptable primary key."
+                   if [ -z "$sshKey" ] ; then
+                       log "   ! primary key could not be translated (not RSA or DSA?)."
+                   else
+                       echo "1:${sshKey}"
+                   fi
                fi
                ;;
            'sub') # sub keys
@@ -352,7 +456,17 @@ process_user_id() {
                lastKey=sub
                lastKeyOK=
                fingerprint=
+               
+               # don't bother with sub keys if the primary key is not valid
+               if [ "$keyOK" != true ] ; then
+                   continue
+               fi
 
+               # don't bother with sub keys if no user ID is acceptable:
+               if [ "$uidOK" != true ] ; then
+                   continue
+               fi
+               
                # if sub key validity is not ok, skip
                if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
                    continue
@@ -368,51 +482,76 @@ process_user_id() {
            'fpr') # key fingerprint
                fingerprint="$uidfpr"
 
+               sshKey=$(gpg2ssh "$fingerprint")
+
                # if the last key was the pub key, skip
                if [ "$lastKey" = pub ] ; then
                    continue
                fi
-               
-               # output a line for the last subkey
+
+               # output a line for the sub key
                # 0 = ok, 1 = bad
                if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
-                   log "  * acceptable key found."
-                   echo "0:${fingerprint}"
+                   log "  * acceptable sub key."
+                   if [ -z "$sshKey" ] ; then
+                       log "    ! sub key could not be translated (not RSA or DSA?)."
+                   else
+                       echo "0:${sshKey}"
+                   fi
                else
-                   echo "1:${fingerprint}"
+                   log "  - unacceptable sub key."
+                   if [ -z "$sshKey" ] ; then
+                       log "    ! sub key could not be translated (not RSA or DSA?)."
+                   else
+                       echo "1:${sshKey}"
+                   fi
                fi
                ;;
        esac
-    done
+    done | sort -t: -k1 -n -r
+    # NOTE: this last sort is important so that the "good" keys (key
+    # flag '0') come last.  This is so that they take precedence when
+    # being processed in the key files over "bad" keys (key flag '1')
 }
 
 # process a single host in the known_host file
 process_host_known_hosts() {
     local host
     local userID
+    local nKeys
+    local nKeysOK
     local ok
-    local keyid
+    local sshKey
     local tmpfile
-    local returnCode
-
-    # default return code is 1, which assumes no key was found
-    returnCode=1
 
     host="$1"
+    userID="ssh://${host}"
 
-    log "processing host: $host"
+    log "processing: $host"
 
-    userID="ssh://${host}"
+    nKeys=0
+    nKeysOK=0
+
+    IFS=$'\n'
+    for line in $(process_user_id "${userID}") ; do
+       # note that key was found
+       nKeys=$((nKeys+1))
 
-    for line in $(process_user_id "ssh://${host}") ; do
        ok=$(echo "$line" | cut -d: -f1)
-       keyid=$(echo "$line" | cut -d: -f2)
+       sshKey=$(echo "$line" | cut -d: -f2)
 
-       sshKey=$(gpg2ssh "$keyid")
-       # remove the old host key line
+        if [ -z "$sshKey" ] ; then
+            continue
+        fi
+
+       # remove the old host key line, and note if removed
        remove_line "$KNOWN_HOSTS" "$sshKey"
+
        # if key OK, add new host line
        if [ "$ok" -eq '0' ] ; then
+           # note that key was found ok
+           nKeysOK=$((nKeysOK+1))
+
            # hash if specified
            if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
                # FIXME: this is really hackish cause ssh-keygen won't
@@ -425,25 +564,38 @@ process_host_known_hosts() {
            else
                ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
            fi
-           # set return code to be 0, since a key was found
-           returnCode=0
        fi
-       return "$returnCode"
     done
 
-    return "$returnCode"
+    # if at least one key was found...
+    if [ "$nKeys" -gt 0 ] ; then
+       # if ok keys were found, return 0
+       if [ "$nKeysOK" -gt 0 ] ; then
+           return 0
+       # else return 2
+       else
+           return 2
+       fi
+    # if no keys were found, return 1
+    else
+       return 1
+    fi
 }
 
 # update the known_hosts file for a set of hosts listed on command
 # line
 update_known_hosts() {
+    local nHosts
+    local nHostsOK
+    local nHostsBAD
+    local fileCheck
     local host
-    local returnCode
 
-    # default return code is 0, which assumes a key was found for
-    # every host.  code will be set to 1 if a key is not found for at
-    # least one host
-    returnCode=0
+    # the number of hosts specified on command line
+    nHosts="$#"
+
+    nHostsOK=0
+    nHostsBAD=0
 
     # set the trap to remove any lockfiles on exit
     trap "lockfile-remove $KNOWN_HOSTS" EXIT
@@ -451,10 +603,22 @@ update_known_hosts() {
     # create a lockfile on known_hosts
     lockfile-create "$KNOWN_HOSTS"
 
+    # note pre update file checksum
+    fileCheck="$(file_hash "$KNOWN_HOSTS")"
+
     for host ; do
-       # process the host, change return code if host key not found
-       process_host_known_hosts "$host" || returnCode=1
-       
+       # process the host
+       process_host_known_hosts "$host"
+       # note the result
+       case "$?" in
+           0)
+               nHostsOK=$((nHostsOK+1))
+               ;;
+           2)
+               nHostsBAD=$((nHostsBAD+1))
+               ;;
+       esac
+
        # touch the lockfile, for good measure.
        lockfile-touch --oneshot "$KNOWN_HOSTS"
     done
@@ -462,72 +626,114 @@ update_known_hosts() {
     # remove the lockfile
     lockfile-remove "$KNOWN_HOSTS"
 
-    return "$returnCode"
+    # note if the known_hosts file was updated
+    if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
+       log "known_hosts file updated."
+    fi
+
+    # if an acceptable host was found, return 0
+    if [ "$nHostsOK" -gt 0 ] ; then
+       return 0
+    # else if no ok hosts were found...
+    else
+       # if no bad host were found then no hosts were found at all,
+       # and return 1
+       if [ "$nHostsBAD" -eq 0 ] ; then
+           return 1
+       # else if at least one bad host was found, return 2
+       else
+           return 2
+       fi
+    fi
 }
 
-# process known_hosts file, going through line-by-line, extract each
-# host, and process with the host processing function
+# process hosts from a known_hosts file
 process_known_hosts() {
-    local returnCode
+    local hosts
 
-    # default return code is 0, which assumes a key was found for
-    # every host.  code will be set to 1 if a key is not found for at
-    # least one host
-    returnCode=0
+    log "processing known_hosts file..."
 
-    # take all the hosts from the known_hosts file (first field), grep
-    # out all the hashed hosts (lines starting with '|')...
-    for line in $(cat "$KNOWN_HOSTS" | meat | cut -d ' ' -f 1 | grep -v '^|.*$') ; do
-       # break up hosts into separate words
-       update_known_hosts $(echo "$line" | tr , ' ') || returnCode=1
-    done
+    hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
 
-    return "$returnCode"
+    if [ -z "$hosts" ] ; then
+       log "no hosts to process."
+       return
+    fi
+
+    # take all the hosts from the known_hosts file (first
+    # field), grep out all the hashed hosts (lines starting
+    # with '|')...
+    update_known_hosts $hosts
 }
 
 # process uids for the authorized_keys file
 process_uid_authorized_keys() {
     local userID
+    local nKeys
+    local nKeysOK
     local ok
-    local keyid
-    local returnCode
-
-    # default return code is 1, which assumes no key was found
-    returnCode=1
+    local sshKey
 
     userID="$1"
 
-    log "processing user ID: $userID"
+    log "processing: $userID"
+
+    nKeys=0
+    nKeysOK=0
 
+    IFS=$'\n'
     for line in $(process_user_id "$userID") ; do
+       # note that key was found
+       nKeys=$((nKeys+1))
+
        ok=$(echo "$line" | cut -d: -f1)
-       keyid=$(echo "$line" | cut -d: -f2)
+       sshKey=$(echo "$line" | cut -d: -f2)
+
+        if [ -z "$sshKey" ] ; then
+            continue
+        fi
 
-       sshKey=$(gpg2ssh "$keyid")
        # remove the old host key line
        remove_line "$AUTHORIZED_KEYS" "$sshKey"
+
        # if key OK, add new host line
        if [ "$ok" -eq '0' ] ; then
-           ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
+           # note that key was found ok
+           nKeysOK=$((nKeysOK+1))
 
-           # set return code to be 0, since a key was found
-           returnCode=0
+           ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
        fi
     done
 
-    return "$returnCode"
+    # if at least one key was found...
+    if [ "$nKeys" -gt 0 ] ; then
+       # if ok keys were found, return 0
+       if [ "$nKeysOK" -gt 0 ] ; then
+           return 0
+       # else return 2
+       else
+           return 2
+       fi
+    # if no keys were found, return 1
+    else
+       return 1
+    fi
 }
 
 # update the authorized_keys files from a list of user IDs on command
 # line
 update_authorized_keys() {
     local userID
-    local returnCode
+    local nIDs
+    local nIDsOK
+    local nIDsBAD
+    local fileCheck
 
-    # default return code is 0, which assumes a key was found for
-    # every user ID.  code will be set to 1 if a key is not found for
-    # at least one user ID
-    returnCode=0
+    # the number of ids specified on command line
+    nIDs="$#"
+
+    nIDsOK=0
+    nIDsBAD=0
 
     # set the trap to remove any lockfiles on exit
     trap "lockfile-remove $AUTHORIZED_KEYS" EXIT
@@ -535,10 +741,26 @@ update_authorized_keys() {
     # create a lockfile on authorized_keys
     lockfile-create "$AUTHORIZED_KEYS"
 
+    # note pre update file checksum
+    fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
+
+    # remove any monkeysphere lines from authorized_keys file
+    remove_monkeysphere_lines "$AUTHORIZED_KEYS"
+
     for userID ; do
        # process the user ID, change return code if key not found for
        # user ID
-       process_uid_authorized_keys "$userID" || returnCode=1
+       process_uid_authorized_keys "$userID"
+
+       # note the result
+       case "$?" in
+           0)
+               nIDsOK=$((nIDsOK+1))
+               ;;
+           2)
+               nIDsBAD=$((nIDsBAD+1))
+               ;;
+       esac
 
        # touch the lockfile, for good measure.
        lockfile-touch --oneshot "$AUTHORIZED_KEYS"
@@ -547,151 +769,50 @@ update_authorized_keys() {
     # remove the lockfile
     lockfile-remove "$AUTHORIZED_KEYS"
 
-    return "$returnCode"
+    # note if the authorized_keys file was updated
+    if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
+       log "authorized_keys file updated."
+    fi
+
+    # if an acceptable id was found, return 0
+    if [ "$nIDsOK" -gt 0 ] ; then
+       return 0
+    # else if no ok ids were found...
+    else
+       # if no bad ids were found then no ids were found at all, and
+       # return 1
+       if [ "$nIDsBAD" -eq 0 ] ; then
+           return 1
+       # else if at least one bad id was found, return 2
+       else
+           return 2
+       fi
+    fi
 }
 
 # process an authorized_user_ids file for authorized_keys
 process_authorized_user_ids() {
-    local userid
-    local returnCode
-
-    # default return code is 0, and is set to 1 if a key for a user ID
-    # is not found
-    returnCode=0
+    local line
+    local nline
+    local userIDs
 
     authorizedUserIDs="$1"
 
-    # set the IFS to be newline for parsing the authorized_user_ids
-    # file.  can't find it in BASH(1) (found it on the net), but it
-    # works.
-    IFS=$'\n'
-    for userid in $(cat "$authorizedUserIDs" | meat) ; do
-       update_authorized_keys "$userid" || returnCode=1
-    done
-
-    return "$returnCode"
-}
-
-# EXPERIMENTAL (unused) process userids found in authorized_keys file
-# go through line-by-line, extract monkeysphere userids from comment
-# fields, and process each userid
-# NOT WORKING
-process_authorized_keys() {
-    local authorizedKeys
-    local userID
-    local returnCode
-
-    # default return code is 0, and is set to 1 if a key for a user
-    # is not found
-    returnCode=0
-
-    authorizedKeys="$1"
-
-    # take all the monkeysphere userids from the authorized_keys file
-    # comment field (third field) that starts with "MonkeySphere uid:"
-    # FIXME: needs to handle authorized_keys options (field 0)
-    cat "$authorizedKeys" | meat | \
-    while read -r options keytype key comment ; do
-       # if the comment field is empty, assume the third field was
-       # the comment
-       if [ -z "$comment" ] ; then
-           comment="$key"
-       fi
+    log "processing authorized_user_ids file..."
 
-       if echo "$comment" | egrep -v -q '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}' ; then
-           continue
-       fi
-       userID=$(echo "$comment" | awk "{ print $2 }")
-       if [ -z "$userID" ] ; then
-           continue
-       fi
-
-       # process the userid
-       log "processing userid: '$userID'"
-       process_user_id "$userID" > /dev/null || returnCode=1
-    done
-
-    return "$returnCode"
-}
-
-##################################################
-### GPG HELPER FUNCTIONS
-
-# retrieve key from web of trust, and set owner trust to "full"
-# if key is found.
-trust_key() {
-    local keyID
-    local trustLevel
-
-    keyID="$1"
-    trustLevel="$2"
-
-    if [ -z "$keyID" ] ; then
-       failure "You must specify key to trust."
+    if ! meat "$authorizedUserIDs" > /dev/null ; then
+       log "no user IDs to process."
+       return
     fi
 
-    # get the key from the key server
-    if ! gpg --keyserver "$KEYSERVER" --recv-key "$keyID" ; then
-       failure "Could not retrieve key '$keyID'."
-    fi
-
-    # get key fingerprint
-    fingerprint=$(get_key_fingerprint "$keyID")
-
-    echo "key found:"
-    gpg --fingerprint "$fingerprint"
-
-    while [ -z "$trustLevel" ] ; do
-       cat <<EOF
-Please decide how far you trust this user to correctly verify other users' keys
-(by looking at passports, checking fingerprints from different sources, etc.)
-
-  1 = I don't know or won't say
-  2 = I do NOT trust
-  3 = I trust marginally
-  4 = I trust fully
-  5 = I trust ultimately
+    nline=0
 
-EOF
-       read -p "Your decision? " trustLevel
-       if echo "$trustLevel" | grep -v "[1-5]" ; then
-           echo "Unknown trust level '$trustLevel'."
-           unset trustLevel
-       elif [ "$trustLevel" = 'q' ] ; then
-           failure "Aborting."
-       fi
+    # extract user IDs from authorized_user_ids file
+    IFS=$'\n'
+    for line in $(meat "$authorizedUserIDs") ; do
+       userIDs["$nline"]="$line"
+       nline=$((nline+1))
     done
 
-    # attach a "non-exportable" signature to the key
-    # this is required for the key to have any validity at all
-    # the 'y's on stdin indicates "yes, i really want to sign"
-    echo -e 'y\ny' | gpg --quiet --lsign-key --command-fd 0 "$fingerprint"
-
-    # index trustLevel by one to difference between level in ui and level
-    # internally
-    trustLevel=$((trustLevel+1))
-
-    # import new owner trust level for key
-    echo "${fingerprint}:${trustLevel}:" | gpg --import-ownertrust
-    if [ $? = 0 ] ; then
-       log "Owner trust updated."
-    else
-       failure "There was a problem changing owner trust."
-    fi 
-}
-
-# publish server key to keyserver
-publish_server_key() {
-    read -p "really publish key to $KEYSERVER? [y|N]: " OK; OK=${OK:=N}
-    if [ ${OK/y/Y} != 'Y' ] ; then
-       failure "aborting."
-    fi
-
-    # publish host key
-    # FIXME: need to figure out better way to identify host key
-    # dummy command so as not to publish fakes keys during testing
-    # eventually:
-    #gpg --keyserver "$KEYSERVER" --send-keys $(hostname -f)
-    failure "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development).
-To publish manually, do: gpg --keyserver $KEYSERVER --send-keys $(hostname -f)"
+    update_authorized_keys "${userIDs[@]}"
 }